#include <fstream.h>
#include <map>
#include <algorithm>
#include <vector>
#include <assert.h>
ifstream in("atlantis.in");
vector<double> koor[2];

#define eps 1e-8

int epseq(double d1, double d2)
{
    if (d1+eps>d2&&d1-eps<d2) return 1;
    
    return 0;
    
}


int koor2pos(double d, int i)
{
    for (int j=0; j<koor[i].size(); j++)
    {
        if (epseq(d,koor[i][j])) return j;
    }
    assert(false);
    
}


int main()
{
    for (int kase=1;;kase++)
    {
        int n;
        
        in>>n;
        if (n==0) break;
        
        map<double,int> t;
        int m[300][300];
        double x[300][2];
        double y[300][2];
        koor[0].clear();
        koor[1].clear();
        koor[0].push_back(0);
        koor[1].push_back(0);
        koor[0].push_back(1000000);
        koor[1].push_back(1000000);
        
        
        for (int i=0; i<300; i++)
        {
            fill_n(m[i],300,0);
        }
        for (int i=0; i<n; i++)
        {
            double x1,x2,y1,y2;
            
            in>>x1>>y1>>x2>>y2;
            koor[0].push_back(x1);
            koor[1].push_back(y1);
            koor[0].push_back(x2);
            koor[1].push_back(y2);
            x[i][0]=x1;
            x[i][1]=x2;
            y[i][0]=y1;
            y[i][1]=y2;
            
        }
        sort(koor[0].begin(),koor[0].end());
        sort(koor[1].begin(),koor[1].end());
        for (int i=0; i<2; i++)
            for (int j=1; j<koor[i].size(); j++)
            {
                if (koor[i][j-1]-eps<koor[i][j]&&koor[i][j-1]+eps>koor[i][j])
                {
                    koor[i].erase(koor[i].begin()+j);
                    j--;
                    
                }
                
            }
        for (int i=0; i<n; i++)
        {
            int x1,y1,x2,y2;
            x1=koor2pos(x[i][0],0);
            x2=koor2pos(x[i][1],0);
            y1=koor2pos(y[i][0],1);
            y2=koor2pos(y[i][1],1);
            
            for (int j=x1; j<x2; j++)
                for (int k=y1; k<y2; k++)
                    m[j][k]=1;
        }
        double res=0;
        
        for (int i=0;i<koor[0].size()-1; i++)
            for (int j=0; j<koor[1].size()-1; j++)
                if (m[i][j])
                    res+=(koor[0][i+1]-koor[0][i])*(koor[1][j+1]-koor[1][j]);
        cout.setf(ios::fixed, ios::floatfield);
        cout.precision(2);
        
        cout<<"Test case #"<<kase<<endl;;
        cout<<"Total explored area: "<<res<<endl<<endl;
        
        
        
         
        
        
    }
    
    return 0;
    
}
