#include <fstream>
#include <iostream>
#include <vector>
#include <string>
#include <assert.h>
#include <queue>
#include <map>
#include <iomanip>

#define oo 1000000000

ifstream in("railroad.in");


typedef pair <int,int> Tp;
typedef struct sdlakjfg { int to, dep, arr; } tV;

map<string,int> ccc;
string s1,s2;
typedef vector<tV> tVL;
vector<tVL> vv, rr;



int main () 
{
    cout.fill('0');
    
    int scen=0;
    while (1) 
    {
        ccc.clear();
        int C;
        in >> C;
        if (!C) return 0;
        cout << "Scenario #" << (++scen) << endl;
        
        getline(in, s1);
        for (int i=0; i<C; i++) 
        {
            getline(in, s1);
            ccc[s1]=i;
        }


        vv=vector<tVL> (C);
        rr=vector<tVL> (C);
        int T;
        in >> T;
        for (int i=0; i<T; i++) 
        {
            int U;
            in >> U;
            if (!U) continue;
            int t1, t2;
            in >> t1 >> ws;
            getline(in, s1);
            for (int j=1; j<U; j++) 
            {
                in >> t2 >> ws; getline(in, s2);
                {
                    tV v, r;
                    v.to = ccc[s2]; v.dep=t1; v.arr=t2;
                    vv[ccc[s1]].push_back(v);
                    r.to = ccc[s1]; r.dep=t1; r.arr=t2;
                    rr[ccc[s2]].push_back(r);
                }
                s1=s2; t1=t2;
            }
        }
        
        // query
        int t0,q0,tn,qn;
        in >> t0;
        getline(in, s1);
        getline(in, s1);
        assert(ccc.find(s1) != ccc.end());
        q0 = ccc[s1];
        getline(in, s2);
        assert(ccc.find(s2) != ccc.end());
        qn = ccc[s2];
        
        {
            priority_queue<Tp> q;
            q.push(Tp(t0,q0));
            vector <int> d(C,oo);
            d[q0]=t0;
            while (!q.empty()) 
            {
                Tp f = q.top(); q.pop();
                if (f.first != d[f.second]) continue;
                
                tVL l=vv[f.second];
                for(tVL::iterator i=l.begin(); i!=l.end(); i++)
                    if (f.first <= (*i).dep && (*i).arr < d[(*i).to]) 
                    {
                        d[(*i).to] = (*i).arr;
                        q.push(Tp(d[(*i).to],(*i).to));
                    }
            }
            
            if (d[qn]==oo) 
            {
                cout << "No connection\n\n";
                continue;
            }
            tn=d[qn];
        }
        

        { // rueckwaerts
            priority_queue<Tp> q;
            q.push(Tp(tn,qn));
            vector <int> d(C,-oo);
            d[qn]=tn;
            while (!q.empty()) 
            {
                Tp f = q.top(); q.pop();
                if (f.first != d[f.second]) continue;

                tVL l=rr[f.second];
                for(tVL::iterator i=l.begin(); i!=l.end(); i++)
                    if (f.first >= (*i).arr && (*i).dep > d[(*i).to]) 
                    {
                        d[(*i).to] = (*i).dep;
                        q.push(Tp(d[(*i).to],(*i).to));
                    }
            }
            
            assert(d[q0]>-oo);
            cout << "Departure " << setw(4) << d[q0] << ' ' << s1 << endl;
            cout << "Arrival   " << setw(4) << tn << ' ' << s2 << endl << endl;
        }
    }
}
